; ---------------------------------------------------------------------------------------------------------------
; EDT6459 - 2019-11-18 - Pere Serrat 	-	Allow modifying colours in CoCo-VGA module mode 64 columns
; ---------------------------------------------------------------------------------------------------------------
; MEMORY MAP for this app:
; $1000-$11ff 	- page to be sent to CoCo-VGA
; $1300-$131f	- palette structure
; $1400-$1c00	- screen for mode SG64
; $2001-$27ff	- Basic ... we must issue a PCLEAR3 to move Basic to $1e00 ($2000 for CoCo)
; $2800-$3fff	- program to run in 16k machines --> $1800 = 6144d
; ---------------------------------------------------------------------------------------------------------------
			ORG	$2800
			PUT	$2800
; ---------------------------------------------------------------------------------------------------------------
; structure for VGA config area and structure for AMC2 boards. MUST begin in a 512 bytes boundary address
; ---------------------------------------------------------------------------------------------------------------
vgaRegs	equ	$1000							; $88 bytes - area to be used to configure VGA. Mandatory for D32
SLOTRST	equ	$00							; offset for reset
SLOTEDT	equ	$01							; offset for edit mask
SLOTFNT	equ	$03							; offset for font
SLOTART	equ	$04							; offset for artifact
SLOTEXT	equ	$05							; offset for extras
SLOTENH	equ	$08							; offset for enhanced modes
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
SLOTBLK	equ	$20							; offset substitute for color BLACK
SLOTGRN	equ	$22							; offset substitute for color GREEN
SLOTYLW	equ	$24							; offset substitute for color YELLOW
SLOTBLU	equ	$26							; offset substitute for color BLUE
SLOTRED	equ	$28							; offset substitute for color RED
SLOTBUF	equ	$2a							; offset substitute for color BUFF
SLOTCYA	equ	$2c							; offset substitute for color CYAN
SLOTMAG	equ	$2e							; offset substitute for color MAGENTA
SLOTORG	equ	$30							; offset substitute for color ORANGE
SLOTDGR	equ	$32							; offset for color dark Green
SLOTDOG	equ	$34							; offset for color dark Orange
SLOTFGT	equ	$80							; offset for text Foreground 
SLOTBGT	equ	$82							; offset for text Background 
SLOTBOR	equ	$84							; offset for Border 
SLOTSCL	equ	$86							; offset for Scanlines
VGALEN	equ	$88							; area length
; ---------------------------------------------------------------------------------------------------------------
; structure for palete data. The palete file *MUST* be loaded here from disk in case we chose that way!
; ---------------------------------------------------------------------------------------------------------------
wrkPal	equ	$1300							; 30 bytes reserved to read-write palete file
wrkNam	equ	$131E							; game name (8 chars)
wrkDesc	equ	$1326							; game description (20 bytes)
palEnd	equ	$1339							; end of area
palLen	equ	palEnd-wrkPal				; value for clearing area (58 bytes)
; - - - - - - - -	- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
PALBLK	equ	00								; 2 bytes for color BLACK
PALGRN	equ	02								; 2 bytes for color GREEN
PALYLW	equ	04								; 2 bytes for color YELLOW
PALBLU	equ	06								; 2 bytes for color BLUE
PALRED	equ	08								; 2 bytes for color RED
PALBUF	equ	10								; 2 bytes for color BUFF
PALCYA	equ	12								; 2 bytes for color CYAN
PALMAG	equ	14								; 2 bytes for color MAGENTA
PALORG	equ	16								; 2 bytes for color ORANGE
PALBOR	equ	18								; 2 bytes for color BORDER
PALDGR	equ	20								; 2 bytes for color dark Green
PALDOG	equ	22								; 2 bytes for color dark Orange
PALFGT	equ	24								; 2 bytes for text Foreground 
PALBGT	equ	26								; 2 bytes for text Background 
PALSCL	equ	28								; 2 bytes for Scanline
PALDUM	equ	30								; 2 unused bytes to round up count
													; for a total length of 32 bytes
; ---------------------------------------------------------------------------------------------------------------
INTDIS	equ	$50							; value to disable interrupts
INTENA	equ	$af							; value to enable interrupts
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BASBEG	equ	$19							; basic beginning area
CHRGET	equ	$9f							; system char get routine
CHRGPTR	equ	$a6							; char get pointer
STXTBEG	equ	$0400							; beginning of std text screen
STXTLSTL	equ	$05e0							; beginning of last line in std text screen
STXTEND	equ	$0600							; end of std text screen
SCRBEG	equ	$1400							; 64 columns text screen beginning
SCREND	equ	$1c00							; 64 columns text screen end
RCOMPBEG	equ	SCRBEG+64*6+1				; trick to point to R component value
LASTLINE	equ	SCRBEG+31*64				; point to 1std char of last screen line
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
STATPOS	equ	8*64+8						; position of status code related to tittle
STATREL	equ	2*64+7						; offset from Pointer to component R till Status position
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	IF COCO
TOKENCMD	equ	$b821							; tokenize command
EXECCMD	equ	$adc6							; execute requested command
	ELSE
TOKENCMD	equ	$8f67							; tokenize command
EXECCMD	equ	$84dc							; execute requested command
	ENDIF
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
READKEYB	equ	$a000							; read keyboard
PIA0ADAT	equ	$ff00							; PIA0 side A data register
PIA0BDAT	equ	$ff02							; PIA0 side B data register
PIA0BCTL	equ	$ff03							; PIA0 side B control register
PIA1BDAT	equ	$ff22							; PIA1 sideB data register
SAMADDRS	equ	$ffc6							; 1st address for SAM to define working page in RAM
; ===============================================================================================================
PgmBeg	lbsr 	CopyScr						; show main menu on screen
			clr	curCcs						; set CCS0
			clr	datChg						; no changes done
			lda	#$48							; enable SG/palette and quiet border
			sta	cpyScanL						; extras param default value
			lbsr	CleanVga						; clean VGA area
			lbsr	CleanPal						; clean palette area with name and description
			lbsr	RstModul						; ask CoCo-VGA to reset to default values
			lbsr	UpdRGBs						; update RGB values on screen to synchronize data <-> screen
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
			ldx	#elemOff						; point to offset table
			ldb	#1								; point to first colour element (after black)
			lbsr	Do1Chng						; invert first element
LMeMain	ldx	#menuMain					; point to main menu
			lbsr	PrtMenu						; show it
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
LKey1		ldb	elemen						; get element number
			lda	PIA1BDAT						; get current palette configuration
			cmpb	#11							; was item CSS1?
			beq	SetCss1						; yes, set it
			cmpb	#10							; was item CSS0?
			bne	LKey11						; no, go to keypress control
SetCss0	tst	curCcs						; already in Css0 mode?
			beq	LKey11						; yes, go read keyboard
			anda	#%11110111					; clear bit3 to force colour 0
			clr	curCcs						; reset variable to CCS0
			bra	SetCss						; skip next
SetCss1	tst	curCcs						; already in Css1 mode?
			bne	LKey11						; yes, go read keyboard
			ora	#%00001000					; set bit3 to force colour 1
			ldb	#1								; put this vaue
			stb	curCcs						; to set CCS1
SetCss	sta	PIA1BDAT						; update palette configuration
LKey11	jsr	[READKEYB]					; wait for a keypress
			beq	LKey11						; none? loop
			ldb	elemen						; get current element number
			cmpa	#9								; pressed right?
			lbeq	NRight						; yes, process it
			cmpa	#8								; pressed left?
			lbeq	NLeft							; yes, process it
			cmpa	#94							; pressed up?
			lbeq	NUp							; yes, process it
			cmpa	#10							; pressed down?
			lbeq	NDown							; yes, process it
			cmpa	#'Q'							; was command Exit?
			beq	OpQuit						; yes, process it
			cmpa	#'E'							; was command Edit?
			lbeq	OpEdt							; yes, process it
			cmpa	#'L'							; was command Load?
			beq	LdFile						; yes, exit
			cmpa	#'S'							; was command Save?
			beq	SvFile						; yes, process it
			cmpa	#'D'							; was command Dir?
			beq	DskDir						; yes, process it
			cmpa	#'R'							; was command Reset?
			beq	RstVga						; yes, process it
			bra	LKey11						; loop to read keyboard again
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
DskDir	ldx	#dirTxt						; point to DIR command text
			lbsr	CpyCmd						; copy to command string
			lbsr	SendCmd						; send command to system
			bra	LMeMain						; show main menu again
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
OpQuit	bsr	UsrShure						; tell user if changes not saved
			cmpa	#'B'							; was answer command back? 
			beq	GoBack						; yes, process it
			bra	PgmEx01						; else exit pgm
GoBack	ldx	#menuMain					; point to main menu
			lbsr	PrtMenu						; show it
			bra	LKey11						; loop to read keyboard again
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
UsrShure	lda	#'C'							; continue by default
			tst	datChg						; are there pending changes (not yet saved)?
			beq	UsShuEx						; no, exit immediately
			ldx	#menuQuit					; point to menu quit
			lbsr	PrtMenu						; show it
LKeyQ		jsr	[READKEYB]					; wait for a keypress
			beq	LKeyQ							; none? loop
			cmpa	#'B'							; is command back?
			beq	UsShuEx						; yes, exit
			cmpa	#'C'							; is command continue?
			bne	LKeyQ							; no, reject command and loop
UsShuEx	rts									; return			
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
PgmEx01	ldx	#vgaRegs						; point to VGA area beginning
			lda	cpyScanL						; get scanline bit copy (should be 0 or 4)
			beq	PgmEx02						; if not enabled, skip section and exit
			ora	SLOTEXT,x					; add to current value (maybbe enabling it)
			sta	SLOTEXT,x					; update param
			clr	,x								; no reset
			lda	#$ac							; set edit
			sta	SLOTEDT,x					; param
			lbsr	Switch32						; change to 32 mode to apply scanlines if applicable
PgmEx02	ldx	<CHRGPTR						; get interpreter pointer
			ldd	,x								; get address here
			cmpd	<BASBEG						; is it lower than Basic start?
			blo	NoChange						; yes, skip adjustement
			clr	,x								; clean 2 bytes to avoid
			clr	1,x							; SN error returning to Basic
NoChange	rts									; return to caller (basic program)
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
LdFile	bsr	UsrShure						; tell user changes not saved
			cmpa	#'B'							; was answer command back? 
			beq	GoBack						; yes, go back for next keypress
			lbsr	LoadFile						; load palete from disk
			bra	SvFil01						; tag no changes and loopback
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
SvFile	lbsr	SaveFile						; save palete to disk
SvFil01	clr	datChg						; no changes made
			lbra	LKey11						; loop to read keyboard again
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
RstVga	bsr	UsrShure						; tell user changes not saved
			cmpa	#'B'							; was answer command back? 
			beq	GoBack						; yes, go back for next keypress
			lbsr	CleanVga						; clean VGA area
			lbsr	RstModul						; ask CoCo-VGA to reset to default values
			lbsr	UpdRGBs						; update RGB values on screen
			lda	#1								; set to true
			sta	datChg						; changes made variable
			bra	GoBack						; to show previous menu
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
OpEdt		lbsr	EditCol						; call menu Edit
			lbra	LKey1							; loop to read keyboard again verifying CSS
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
NDown		cmpb	#9								; is current element already in the last row?
			lbhi	LKey11						; yes, reject command
			addb	#5								; point to element down on next row
			bra	DoChange						; update titles
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
NUp		cmpb	#5								; is current element already in the first row?
			lblo	LKey11						; yes, reject command
			subb	#5								; point to element up on previous row
			bra	DoChange						; update titles
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
NLeft		tstb									; is current element already the first one?
			lbeq	LKey11						; yes, reject command
			decb									; point to previous element
			bra	DoChange						; update titles
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
NRight	cmpb	#14							; is current element already the last one?
			lbhs	LKey11						; yes, reject command
			incb 									; point to next element
; ---------------------------------------------------------------------------------------------------------------
; first restore old element title. Use regB as new element and invert title
; ---------------------------------------------------------------------------------------------------------------
DoChange	bsr	Change						; to allow for multi-use
			lbra	LKey1							; loop to read keyboard again verifying CSSn
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
Change	pshs	b								; save requested item number
			ldx	#elemOff						; point to offset table
			ldb	elemen						; get current element number
			bsr	InvElem						; invert title
			puls	b								; get requested number
Do1Chng	stb	elemen						; update variable
			bsr	InvElem						; invert title
			rts									; return
; ---------------------------------------------------------------------------------------------------------------
; invert title on current colour element. regB = element number
; ---------------------------------------------------------------------------------------------------------------
InvElem	aslb									; calculate table offset
			ldd	b,x							; get offset for requested item
			ldu	#SCRBEG						; point to screen beginning
			leau	d,u							; point to item tittle
			stu	titlePtr						; save address
			ldb	#9								; number of chars to invert
DoCh01	lda	,u								; get a char
			eora	#64							; invert upper <-> lower
			sta	,u+							; update screen
			decb									; decrement counter
			bne	DoCh01						; not done? loopback
			rts									; return
; ---------------------------------------------------------------------------------------------------------------
; subroutine to print a whole message pointed by regX
; ---------------------------------------------------------------------------------------------------------------
PrtMenu	ldu	#LASTLINE					; point to menu screen line
PrntStr	lda	,x+							; get a char from string
			beq	PrntEx01						; if got to the end, exit
			cmpa	#124							; is it '<' sign?
			beq	Prnt1							; yes, print it
			cmpa	#126							; is it '>' sign?
			beq	Prnt1							; yes, print it
			cmpa	#32							; is it a space?
			bne	PrtM01						; no, skip next two
			lda	#128							; change by a black space
PrtM01	cmpa	#96							; is it lowercase?
			ble	Prnt1							; no, skip next
			anda	#%10011111					; convert ASCII to POKE value
Prnt1		sta	,u+							; put on screen
			bra	PrntStr						; go for next char
PrntEx01	rts									; return			
; --------------------------------------------------------------------------------------------------------------------------------------------------------------------
; recalculates some parameters upon values set in the VGA area
; --------------------------------------------------------------------------------------------------------------------------------------------------------------------
ReCalcP	lda	SLOTEXT,x					; get 'extras' param
			tst	SLOTBOR,x					; is border enabled?
			bpl	NoBorder						; no, skip next one
			ora	#$03							; enable border color			
NoBorder	ora	#$08							; enable quiet border status
			clrb									; by default no scanline
			tst	SLOTSCL,x					; are scanlines enabled?
			bpl	NoScanL						; no, skip next
			ldb	#$04							; put bit2 value
NoScanL	stb	cpyScanL						; to variable (will be 0 or 4)
			tst	SLOTFGT,x					; is foreground text enabled?
			bne	EnaTxtC						; yes, enable it
			tst	SLOTBGT,x					; is background text enabled?
			beq	LfEna							; no, skip next
EnaTxtC	ora	#$80							; enable text colors
LfEna		sta	SLOTEXT,x					; update param
			rts									; return
; --------------------------------------------------------------------------------------------------------------------------------------------------------------------
; load file from disk to palette and VGA areas
; ---------------------------------------------------------------------------------------------------------------
LoadFile	lbsr	CleanVga						; clean VGA area
			lbsr	LoadPal						; read file to palette area
			lbsr	Pal2Vga						; copy data to VGA area
			ldx	#vgaRegs						; point to VGA area
			lda	#$ac							; set bits 7,5,3,2 
			sta	SLOTEDT,x					; in param
			bsr	ReCalcP						; recalculate some parameters
			lbsr	UpdRGBs						; update RGB values on screen to synchronize data <-> screen
			lbsr	ApplyMod						; send page to module
LdFilEx	ldx	#menuMain					; point to main menu
			bsr	PrtMenu						; show it
			rts									; return
; ---------------------------------------------------------------------------------------------------------------
; save VGA area to palete and the to disk
; ---------------------------------------------------------------------------------------------------------------
SaveFile	bsr	CleanPal						; clean palette area
			lbsr	Vga2Pal						; copy VGA data to palette
			lbsr	SavePal						; save file from palette area
			bra	LdFilEx						; restore main menu
			rts									; return
; ---------------------------------------------------------------------------------------------------------------
; clean palette area
; ---------------------------------------------------------------------------------------------------------------
CleanPal	ldx	#wrkPal						; point to palette beginning
			clra									; zero byte
			ldb	#palLen						; palette length
ClPa01	sta	,x+							; clean on ebyte
			decb									; decrement counter
			bne	ClPa01						; not done? loopback
			rts									; return
; ---------------------------------------------------------------------------------------------------------------
; menu for editing options
; ---------------------------------------------------------------------------------------------------------------
EditCol	ldb	elemen						; get element number (color in edition)
			ldx	#elemOff						; point to offset table
			aslb									; calculate table offset
			ldd	b,x							; get offset (2 bytes) for requested item
			ldu	#RCOMPBEG					; ready to point to R value on screen
			leau	d,u							; point to value for R
			stu	rgbPtr						; save working address
			ldx	#menuEdt						; point to menu for editting colors
			lbsr	PrtMenu						; show it
			lda	#1								; set 1st component
			sta	edtColN						; being edited
MovComp	lbsr	InvEdtN						; invert 1st component
LKey2		jsr	[READKEYB]					; wait for a keypress
			beq	LKey2							; none? loop
			cmpa	#94							; pressed component up?
			beq	OpCpUp						; yes, process it
			cmpa	#10							; pressed component down?
			beq	OpCpDwn						; yes, process it
			cmpa	#'>'							; pressed > (shifted)
			beq	OpRight						; yes, process it
			cmpa	#'.'							; pressed > (NOT shifted)
			beq	OpRight						; yes, process it
			cmpa	#'<'							; pressed < (shifted)
			beq	OpLeft						; yes, process it
			cmpa	#','							; pressed < (NOT shifted)
			beq	OpLeft						; yes, process it
			cmpa	#'O'							; was command Out (go Back)?
			beq	EdColEx						; exit updating menu line
			cmpa	#'D'							; was command disable this colour change?
			beq	OpDis							; yes, process it
			cmpa	#'E'							; was command enable this colour change?
			beq	OpEna							; yes, process it
			bra	LKey2							; loop to read keyboard again
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
OpCpUp	lda	edtColN						; get current component
			cmpa	#1								; already at 1st one?
			beq	LKey2							; yes, reject commad
			lbsr	InvEdtN						; invert current component value
			dec	edtColN						; go one up
			bra	MovComp						; invert requested one
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
OpCpDwn	lda	edtColN						; get current component
			cmpa	#3								; already at 1st one?
			beq	LKey2							; yes, reject commad
			lbsr	InvEdtN						; invert current component value
			inc	edtColN						; go one down
			bra	MovComp						; invert requested one
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
OpRight	bsr	GetCurV						; get current value
			cmpa	#7								; has already max value?
			beq	LKey2							; yes, reject commad
			inca									; increment value
			bra	OpLef01						; update value and loopback
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
OpLeft	bsr	GetCurV						; get current value
			tsta									; has already min value?
			beq	LKey2							; yes, reject commad
			deca									; decrement value
OpLef01	bsr	UpdCurV						; update value on screen and VGA area
			bra	LKey2							; loop to read keyboard again
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
OpDis		lda	#4								; for 'd'
			bra	PutLetr						; skip next
OpEna		lda	#5								; for 'e'
PutLetr	ldx	titlePtr						; get pointer to item title
			cmpa	STATPOS,x					; already same state?
			beq	OpDisEx						; yes, exit
			sta	STATPOS,x					; update status on screen
			lbsr	UpdSta						; update 1st byte in VGA area for this item to show its new state (bit 7)
			bsr	UpdTrick						; send change to VGA module 
			lda	#1								; set to true
			sta	datChg						; changes done variable
OpDisEx	bra	LKey2							; loop to read keyboard again
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
EdColEx	bsr	InvEdtN						; invert current number being edited
			ldx	#menuMain					; point to main menu
			lbsr	PrtMenu						; show it
			rts									; return
; ---------------------------------------------------------------------------------------------------------------
; trick to avoid scanlines to be shown even when enabled. In mode 64 columns the text is made of 6 data lines 
; instead of 12 lines as it is in mode 32 columns, so adding a scanline every two makes the text hardly readable.
; The program saves the scanlines status in a variable and sets it on exiting the program if enabled
; ---------------------------------------------------------------------------------------------------------------
UpdTrick										; first save scanline status to variable cpyScanL
			ldx	#vgaRegs						; point to VGA area beginning
			lda	SLOTEXT,x					; get extras param
			anda	#%00000100					; value for scanlines
			sta	cpyScanL						; save value into variable ( 0 or 4)
												; now disable scanlines before updating VGA module
			lda	SLOTEXT,x					; disable scanlines
			anda	#%11111011					; resetting bit2
			sta	SLOTEXT,x					; update ScanLine 1st byte
			lbsr	SetModT						; send info from VGA area to module
												; finally restore teh scanline bit in param 'extras'
			ldx	#vgaRegs						; point to VGA area beginning
			lda	cpyScanL						; get value from variale
			ora	SLOTEXT,x					; add to current value
			sta	SLOTEXT,x					; update it
			rts									; return
; ---------------------------------------------------------------------------------------------------------------
; return current char (poke value) in regA and offset to regX in regB. Input Param in edtColN
; offset (regB) must be: 0, 64, 128 because base offset already points to first component (R)
; ---------------------------------------------------------------------------------------------------------------
GetChrV	ldb	#-64							; offset to row above R tittle
			lda	edtColN						; get component being edited
GetCh01	addb	#64							; jump to next component (next row)
			deca									; decrement counter
			bne	GetCh01						; not done? loop
			ldx	rgbPtr						; get pointer to first color value
			clra									; make 16 bits offset
			lda	d,x							; get current value
			rts									; return
; ---------------------------------------------------------------------------------------------------------------
; return current component value in regA and offset to be added to regX in regB. Input Param in edtColN
; ---------------------------------------------------------------------------------------------------------------
GetCurV	bsr	GetChrV						; get current char
			anda	#7								; use lower three bits
			rts									; return
; ---------------------------------------------------------------------------------------------------------------
; update current component value in regA and update VGA area accordingly
; params: regB - offset to this item number (unsigned)
;			 regX - pointer to 1st value (for R component)
; ---------------------------------------------------------------------------------------------------------------
UpdCurV	pshs	a								; save new value
			bsr	GetChrV						; get current offset at regB and address at regX
			puls	a								; restore new value
			ora	#%01110000					; force non inverted number
			abx									; calculate address
			sta	,x								; update screen
			bsr	UpdCmp						; update VGA area accordingly
			tsta									; is current color Enabled?
			beq	UpdCEx						; no, exit
			bsr	UpdTrick						; call trick to send data to module
			lda	#1								; set to true
			sta	datChg						; data changed variable
UpdCEx	rts									; return
; ---------------------------------------------------------------------------------------------------------------
; invert item figure on screen
; params: regB - offset to this item number (unsigned)
; ---------------------------------------------------------------------------------------------------------------
InvEdtN	bsr	GetChrV						; get current poke value
			eora	#64							; toggle number normal-inverted
			abx									; calculate screen position
			sta	,x								; update figure on screen
			rts									; return
; ---------------------------------------------------------------------------------------------------------------
; update component data in VGA area for an item
; input params: 	regA - value to be saved
; 						regB - offset to line above current component being edited: 64-128-192 -> R G B
; ---------------------------------------------------------------------------------------------------------------
UpdCmp	anda	#7								; ensure use of 3 lower bits only (values 0-7)
			pshs	a,b							; save new value and current offset to screen value
			ldx	#vgaOff						; point to VGA offsets table
			ldb	elemen						; get item number being processed
			ldb	b,x							; get offset to requested item
			clra									; make 16 bits offset
			ldx	#vgaRegs						; point to VGA area beginning
			leax	d,x							; point to 1st byte for requested colour item
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
			ldb	1,s							; get received offset
			beq	UpdR							; if it was for component R, process it
			cmpb	#64							; was for G component?
			beq	UpdG							; yes, process G
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
UpdB		lda	1,x							; get current 2nd byte value
			anda	#%11100011					; clear B value	
			sta	1,x							; save cleaned value
			lda	,s								; get new value
			asla									; move 3 lower bits
			asla									; to bits 4-3-2
			adda	1,x							; add cleaned value
			sta	1,x							; update 2nd byte
			bra	UpdEx							; exit cleaning stack
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
UpdG		ldd	,x								; get both bytes
			anda	#%11111100					; clear
			andb	#%01111111					; G value
			std	,x								; save cleaned values
			lda	,s								; get new value
			clrb									; clean 2nd byte
			lsra									; move bits 2-1 to bits 1-0, bit 0 goes to carry
			rorb									; receive carry (bit0) into bit7
			addd	,x								; add cleaned values
			std	,x								; update both bytes
			bra	UpdEx							; exit cleaning stack
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
UpdR		lda	,x								; get current 1st byte value
			anda	#%10001111					; clear R value
			sta	,x								; save cleaned value
			lda	,s								; get new value
			asla									; move 3
			asla									; lower bits
			asla									; to bits
			asla									; 6-5-4
			adda	,x								; add cleaned value
			sta	,x								; update 1st byte
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
UpdEx		tst	,x								; see bit7 (enabled or disabled)
			bmi	UpExEna						; if enabled return value 1
UpExDis	clra									; return 0
			bra	UpdEx1						; skip next
UpExEna	lda	#1								; return 1
UpdEx1	leas	2,s							; clean stack
			rts									; return
; ---------------------------------------------------------------------------------------------------------------
; update state in VGA area for an item
; State is bit7 of first data byte for any colour item
; regA comes with value '4' or '5' designing Disable - Enable
; ---------------------------------------------------------------------------------------------------------------
UpdSta	pshs	a								; save parameter
			ldx	#vgaOff						; point to offsets table
			ldb	elemen						; get item number being processed
			ldb	b,x							; get offset to requested item
			clra									; make 16 bits offset
			ldx	#vgaRegs						; point to VGA area beginning
			leax	d,x							; point to 1st byte
			ldb	,x								; get it
			lda	,s								; get parameter from stack
			cmpa	#4								; is actual status Disable?
			beq	UpdDis						; yes, process it
UpdEna	orb	#%10000000					; set bit7
			bra	UpdUpd						; skip next
UpdDis	andb	#%01111111					; reset bit7			
UpdUpd	stb	,x								; update 1st byte in VGA area
												; params that must be changed upon element being modified
			puls	a								; restore param from stack
			cmpa	#4								; is it disable?
			bne	UpEnaPar						; no, process enable parameters
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
UpDisPar	ldx	#vgaRegs						; point to VGA data area
			ldu	#vgaOff						; point to VGA offsets table
			ldb	elemen						; get element being processed
			cmpb	#9								; is it border?
			beq	DisBder						; yes, process it
			cmpb	#12							; is it foreground text?
			beq	DisFGT						; yes, process it
			cmpb	#13							; is it background text?
			beq	DisBGT						; yes, process it
			cmpb	#14							; is it scanlines?
			bne	UpDisEx						; no, exit
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
DisScan	lda	SLOTEXT,x					; get 'extras' param
			anda	#$fb							; reset bit2
			sta	SLOTEXT,x					; update param
			rts									; return
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
DisBder	lda	SLOTEXT,x					; get 'extras' param
			anda	#$fc							; reset bits1-0
			sta	SLOTEXT,x					; update param
			rts									; return
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
DisFGT	incb									; index to background text
			fcb	$86							; skips next one converting to: lda #$5a
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
DisBGT	decb									; index to foreground text
			ldb	b,u							; get offset for background text
			clra									; make 16 bits offset
			ldb	d,x							; get 1st byte for that element
			bmi	UpDisEx						; bit 7 set? if yes, exit
			lda	SLOTEXT,x					; get 'extras' param
			anda	#$7f							; reset bit7
			sta	SLOTEXT,x					; update param
UpDisEx	rts									; return
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
UpEnaPar	ldx	#vgaRegs						; point to VGA data area
			ldb	elemen						; get element being processed
			cmpb	#9								; is it border?
			beq	EnaBder						; yes process it
			cmpb	#14 							; is it scanlines?
			beq	EnaScan						; yes process it
			cmpb	#12							; is it lower than foreground?
			blo	EnaCol						; yes process color
			beq	EnaTxt						; yes process foreground
			cmpb	#13							; is it background text?
			bne	UpEnaEx						; no, exit
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
EnaTxt	lda	SLOTEXT,x					; get 'extras' param
			ora	#$80							; set bit 7 for text palette enable
			sta	SLOTEXT,x					; update value
			bra	EnaCom1						; update edit param and exit
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
EnaCol	lda	SLOTEDT,x					; get 'edit mask' param
			ora	#$08							; set bit 3 for semigraphics palette
			sta	SLOTEDT,x					; update value
			rts									; return
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
EnaScan	lda	SLOTEXT,x					; get 'extras' param
			ora	#$04							; set bit 2 for scanline enable
			sta	SLOTEXT,x					; update value
			bra	EnaCom1						; update edit param and exit
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
EnaBder	lda	SLOTEXT,x					; get 'extras' param
			ora	#$03							; set bits 0-1 for border color mode
			sta	SLOTEXT,x					; update value
EnaCom1	lda	SLOTEDT,x					; get 'edit mask' param
			ora	#$24							; set bits 5 and 2 for extra palette and extras
			sta	SLOTEDT,x					; update value
UpEnaEx	rts									; return
; ---------------------------------------------------------------------------------------------------------------
; copies the default menu screen to the std text area $400-$5ff
; ---------------------------------------------------------------------------------------------------------------
CopyScr	ldx	#SCRBEG						; point to destination
			ldu	#mainMenu					; point to default screen
SS01		ldd	,u++							; get 2 bytes
			std	,x++							; put at destination
			cmpx	#SCREND						; got to screen end?
			blo	SS01							; no, loopback
			rts									; return
; ---------------------------------------------------------------------------------------------------------------
; send to CoCo-VGA a page with just the reset byte to $ff
; ---------------------------------------------------------------------------------------------------------------
RstModul	lda	#$ff							; set all features to be set to default values
			sta	vgaRegs						; put in VGA area
			clr	vgaRegs+1					; clear EDIT param
			lbsr	ApplyMod						; send page to module
			bsr	CleanVga						; reset VGA area all bytes
			rts									; return
; ---------------------------------------------------------------------------------------------------------------
; switch to 32x16 mode
; ---------------------------------------------------------------------------------------------------------------
Switch32	ldd	#STXTBEG						; point to std text beginning
			std	PageMod+1					; modify SetMode routine
			lda	#$1c							; to point to -4,x
			sta	SamMod+1						; modify SetMode routine
			clr	CssMod+1						; value for Css0 text mode 32x16
			lbsr	SetModT						; send page to module
			clr	vgaRegs						; no reset in later calls
			rts									; return
; ---------------------------------------------------------------------------------------------------------------
; clear (reset) all bytes in VGA area
; ---------------------------------------------------------------------------------------------------------------
CleanVga	ldx	#vgaRegs						; point to area beginning
			ldb	#VGALEN						; get area length
			clra									; get a zero
ClnV1		sta	,x+							; clean one byte
			decb									; decrement counter
			bne	ClnV1							; not done? loopback
			ldx	#vgaRegs						; point to VGA area
			clr	,x								; clear reset byte
			clr	SLOTEDT,x					; clear edit mask byte
			ldd	#$0D48						; regA: 00001110 -> artifacts
													; regB: 01001000 -> text palette,quiet border
			std	SLOTART,x					; put in VGA area
			rts									; return
; ---------------------------------------------------------------------------------------------------------------
; update RGB values for all 15 elements in screen
; ---------------------------------------------------------------------------------------------------------------
UpdRGBs	clrb									; get a zero
UpRGB1	pshs	b								; save counter
												; point to 1st data value (for R)
			ldx	#elemOff						; point to offset table
			aslb									; calculate table offset
			ldd	b,x							; get offset (2 bytes) for requested item
			ldu	#RCOMPBEG					; ready to point to R value on screen
			leau	d,u							; point to value for R
			stu	rgbPtr						; save working address
												; point to 2 bytes for these item in VGA area
			ldx	#vgaOff						; point to VGA offsets table
			ldb	,s								; get counter from stack
			ldb	b,x							; get offset (1 byte) for this item
			clra									; make 16 bits offset
			ldu	#vgaRegs						; point to area beginning
			ldd	d,u							; get both bytes
			bsr	Extract						; extract and show R,G,B data from them
			puls	b								; get counter
			incb									; increment it
			cmpb	#15							; processed last one?
			blo	UpRGB1						; no, loopback for next one
			rts									; return
; ---------------------------------------------------------------------------------------------------------------
; decode regD to show values RGB for one screen colour item
; ---------------------------------------------------------------------------------------------------------------
Extract	ldu	rgbPtr						; point to R data
			std	datRGB						; store received values for later use
			tsta									; check bit7
			bmi	IsEnabld						; if set skip next two
			ldb	#4								; value for 'd'
			bra	Ext01							; skip next
IsEnabld	ldb	#5								; value for 'e'
Ext01		stb	STATREL,u					; show value enabled/disabled
			lsra									; move R data
			lsra									; to the
			lsra									; lower 
			lsra									; nibble
			anda	#7								; use only 3 bits
			adda	#48							; to convert to inverted number
			sta	,u								; show component R
			ldd	datRGB						; get data again
			rolb									; moves high bit to carry (lower G bit)
			rola									; get carry into bit0
			anda	#7								; use only 3 bits
			adda	#48							; to convert to inverted number
			sta	64,u							; show component G
			lsrb									; move B data
			lsrb									; to the
			lsrb									; lower nibble
			andb	#7								; use only 3 bits
			addb	#48							; to convert to inverted number
			stb	128,u							; show component B
			rts									; return
; ---------------------------------------------------------------------------------------------------------------
; copy VGA area to palette structure
; ---------------------------------------------------------------------------------------------------------------
Vga2Pal	ldx	#vgaRegs						; point to VGA source area
			ldu	#wrkPal						; point to destination palette area
			ldy	#vgaOff						; point to VGA offset table
			clr	,-s							; create and reset a counter in stack
Vga2P01	ldb	,s								; get counter from stack
			cmpb	#15							; got to the end?
			bhs	Vga2PEx						; yes, exit
			ldb	b,y							; get VGA offset for this item
			clra									; make 16 bits offset
			ldd	d,x							; get 2 bytes from VGA area (signed addition)
			std	,u++							; copy to palette area and move pointer
			inc	,s								; increment counter
			bra	Vga2P01						; loopback
Vga2PEx	puls	b,pc							; clean stack and return
; ---------------------------------------------------------------------------------------------------------------
; copy palette area to VGA area
; ---------------------------------------------------------------------------------------------------------------
Pal2Vga	ldu	#wrkPal						; point to loaded palette area
			ldy	#vgaOff						; point to VGA offset table
			clr	,-s							; create and reset a counter in stack
Pal2V01	ldb	,s								; get counter from stack
			cmpb	#15							; got to the end?
			bhs	Pal2VEx						; yes, exit
			ldb	b,y							; get VGA offset for this item
			clra									; make 16 bits offset
			ldx	#vgaRegs						; point to VGA beginning area
			leax	d,x							; point to destination item data (unsigned addition)
			ldd	,u++							; get 2 bytes from palette and move pointer 
			std	,x								; copy to VGA area
			inc	,s								; increment counter
			bra	Pal2V01						; loopback
Pal2VEx	puls	b,pc							; clean stack and return
; --------------------------------------------------------------------------------------------------------------------------------------------------------------------
; subroutines to LOAD and SAVE from/to disk
; --------------------------------------------------------------------------------------------------------------------------------------------------------------------
LoadPal	lbsr	CleanCmd						; clean command line
			ldx	#loadFil						; point to LOAD command text
			bsr	Perform						; apply this command
			lbsr	LoadAdrs						; add Load address
			lbsr	SendCmd						; send command to DOS
			rts									; return
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
SavePal	lbsr	CleanCmd						; clean command line
			bsr	AddDesc						; add description for that game
			ldx	#saveFil						; point to SAVE command text 
			bsr	Perform						; apply this command
			lbsr	SaveAdrs						; add Load address
			bsr	FilChars						; copy name and description to palette area
			lbsr	SendCmd						; send command to DOS
			rts									; return
; --------------------------------------------------------------------------------------------------------------------------------------------------------------------
; copy filename and game description to palette area
; no need to reset to zero unused chars because CleanPal has already done this
; --------------------------------------------------------------------------------------------------------------------------------------------------------------------
FilChars 									; copy filename to palette beginning
			ldx	#dosParms					; point to name beginning
			ldu	#wrkNam						; point to palette beginning
FilCh01	lda	,x+							; get a received char
			cmpa	#'.'							; is it the dot between name and extension (end of name)?
			beq	FilCh02						; yes, stop copying
			sta	,u+							; copy char to destination
			bra	FilCh01						; go for next char
FilCh02	ldx	#descArea					; point to description beginning
			ldu	#wrkDesc						; point to palette destination
FilCh03	lda	,x+							; get a char
			beq	FilChEx						; if zero, exit copy
			cmpa	#128							; is it a black background byte?
			bne	FilCh04						; no, skip next
			lda	#32							; convert to space
FilCh04	sta	,u+							; put at destination
			bra	FilCh03						; go for next char
FilChEx	rts									; return
; --------------------------------------------------------------------------------------------------------------------------------------------------------------------
Perform	bsr	CpyCmd						; copy command text to command line
			ldx	#textN						; point to message for user
			bsr	ClnShow						; clean line and show text
			bsr	AskName						; wait for user to enter filename
			rts									; return
; --------------------------------------------------------------------------------------------------------------------------------------------------------------------
CpyCmd	ldu	#dosCmd						; point to command line data
	IF COCO
			ldb	#5								; bytes to copy
	ELSE
			ldb	#4								; bytes to copy
	ENDIF
Cpy01		lda	,x+							; get a byte
			sta	,u+							; put in command line
			decb									; decrement counter
			bne	Cpy01							; not done? loop
			rts									; return
; --------------------------------------------------------------------------------------------------------------------------------------------------------------------
AddDesc	lda	#20							; number of chars to be read
			sta	maxChar						; to variable
			clr	numChar						; counter to zero
			ldx	#descArea					; point to destination area
			lda	#128							; get a black backgroung space
			ldb	#19							; number of bytes to clean-1
AddD01	sta	b,x							; clean that one
			decb									; decrement counter (offset)
			bpl	AddD01						; if positive, loopback
			ldx	#descReq						; point to message asking for game description
			bsr	ClnShow						; show it on 64 column mode
			leau	-21,u							; locate cursor to the char after the quotes
			ldx	#descArea					; point to destination area
			ldb	#1								; set to 1
			stb	spcAllw						; flag spaces allowed
			lbsr	WaitNam						; wait for the discription to be filled
			rts									; return
; --------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Show32  prints a message in mode 32. Usefull for DIR so that we can see the last page of directory files.
; ClnShow prints a message in 64 column mode after clearing previous text (for 2 chars). Needed for short messages
; ShowTxt will just print a message without clearing previous text. Useful for Menu bars
; --------------------------------------------------------------------------------------------------------------------------------------------------------------------
Show32	ldu	#STXTLSTL					; point to last line in mode 32x16
			bra	ShwT01						; print text
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ClnShow	ldu	#LASTLINE					; point to last screen line in mode 64 column
			ldd	#$8080						; get two black background spaces
ClnLin	std	,u++							; clean two bytes
			cmpu	#LASTLINE+62				; got to end of line to be cleared?
			blo	ClnLin						; no, loop
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
ShowTxt	ldu	#LASTLINE					; point to last screen line in mode 64 column
ShwT01	lda	,x+							; get a char
			beq	ShwTEx						; if zero, exit
			ora	#$40							; ensure upercase
			sta	,u+							; put on screen
			bra	ShwT01						; go for next char
ShwTEx	rts									; return
; --------------------------------------------------------------------------------------------------------------------------------------------------------------------
AskName	clr	numChar						; counter to zero
			ldx	#dosParms					; point to params area in command line
			lda	#8								; number of chars per name
			sta	maxChar						; to variable
			clr	spcAllw						; reset spaces allowed
			bsr	WaitNam						; wait for filename
			ldd	#".P"							; add .PAL to the command
			std	,x++							; advancing
			ldd	#"AL"							; command
			std	,x++							; pointer
			lda	#'"'							; close name 
			sta	,x+							; with quotes
			rts									; return
; --------------------------------------------------------------------------------------------------------------------------------------------------------------------
SaveAdrs	ldu	#saveMem						; point to save addresses
			bra	AddMem						; go add it
; --------------------------------------------------------------------------------------------------------------------------------------------------------------------
LoadAdrs	bra	Add2CEx						; go add a null
AddMem	bsr	Add2Cmd						; add to command line
			rts									; return
; --------------------------------------------------------------------------------------------------------------------------------------------------------------------
Add2Cmd	lda	,u+							; get a char
			beq	Add2CEx						; if zero exit
			sta	,x+							; put in command line
			bra	Add2Cmd						; go for next char
Add2CEx	clr	,x								; add a final zero
			rts									; return
; --------------------------------------------------------------------------------------------------------------------------------------------------------------------
SendCmd	orcc	#INTDIS						; disable interrupts
			ldx	<CHRGPTR						; get current system pointer ($A6)
			pshs	x								; save on stack
			leax	dosCmd,PCR					; get command line address
			stx	<CHRGPTR						; pass to system pointer
			andcc	#INTENA						; enable interrupts
			jsr	TOKENCMD						; tokenize command string
			jsr	<CHRGET						; get first token
			jsr	EXECCMD						; dispatch command
			lbsr	Pre64							; put params into VGA area
			lbsr	ReCalcP						; recalculate some parameters
			ldx	#doneW						; point to message for the user
												; only DIR neext confirm text to be sent ot mode 32
			lda	dosCmd						; get 1st letter of DOS command issued
			cmpa	#'D'							; was it D for DIR?
			bne	NotDirCm						; yes, skip next, not for Load
			bsr	Show32						; show it in 32x16 mode
			bra	WaitKey						; smkip next
NotDirCm	bsr	ClnShow						; show it in 64x32 mode
WaitKey	clrb									; read all columns
			stb	PIA0BDAT						; send to keyboard
WaitK01	lda	PIA0ADAT						; read keyb
			coma									; invert value
			beq	WaitK01						; if none pressed, loop
			lda	dosCmd						; get 1st letter of DOS command issued
			cmpa	#'L'							; was it L for LOAD?
			beq	IsLdCmd						; yes, skip next, not for Load
			lbsr	SetModT						; send to module ONLY for DIR and SAVE commands
IsLdCmd	puls	x								; get system pointer from stack
			stx	<CHRGPTR						; restore it
			rts									; return
; --------------------------------------------------------------------------------------------------------------------------------------------------------------------
WaitNam	pshs	x,u							; save pointers (command and screen)
WNam01	jsr	[READKEYB]					; read Keyboard
			beq	WNam01						; no keypress, loopback
			ldx	,s								; get command pointer
			ldu	2,s							; and screen pointer
			tst	spcAllw						; are spaces allowed?
			beq	WNam03						; no, skip next two
			cmpa	#32							; space received?
			beq	GoodNum						; yes, accept it
WNam03	cmpa	#13							; enter received?
			beq	WNamEx						; exit
			cmpa	#8								; received backspace?
			bne	WNam02						; no, go to next control
			tst	numChar						; see number of chars received
			beq	WNam01						; if zero no backspace possible, reject keystroke
			dec	numChar						; decrement number of chars
			leax	-1,x							; move command pointer back
			leau	-1,u							; and screen pointer too
			stx	,s								; update pointers
			stu	2,s							; in the stack
			lda	#128							; get a black background block
			sta	,u								; put on screen
			clr	,x								; clean char on command string
			bra	WNam01						; loopback for another keystroke			
WNam02	cmpa	#'0'							; was a sign lower than '0'?
			blo	WNam01						; yes, reject it
			cmpa	#'9'							; was a number lower or equal to 9?
			ble	GoodNum						; yes, use it
			cmpa	#'A'							; was a sign lower than 'A'?
			blo	WNam01						; yes, reject it
			cmpa	#'Z'							; was a sign greater than 'Z'?
			bhi	WNam01						; yes, reject it
GoodNum	sta	,x+							; put char on command line
			ora	#$40							; ensure correct POKE value
			sta	,u+							; put on screen
			stx	,s								; update command pointer
			stu	2,s							; and screen pointer
			inc	numChar						; increment counter
			ldb	numChar						; get char counter
			cmpb	maxChar						; already 8 chars received for name, 24 for description?
			blo	WNam01						; no, loop for more
WNamEx	puls	x,u,pc						; restore pointers and return
; --------------------------------------------------------------------------------------------------------------------------------------------------------------------
CleanCmd	ldx	#dosParms					; point to command line params
			ldb	#PARMLEN						; number of bytes
			clra									; get a zero
ClCm01	sta	,x+							; clean one byte
			decb									; decrement counter
			bne	ClCm01						; not done? loop
			rts									; return
; --------------------------------------------------------------------------------------------------------------------------------------------------------------------
Pre64		ldx	#vgaRegs						; point to VGA area
			clr	,x								; no reset
			lda	#$ac							; registers used in Mode 64
			sta	SLOTEDT,x					; update edit param
			ldd	#$0D48						; regA: 00001110 -> artifacts
													; regB: 01001000 -> text palette,quiet border
			std	SLOTART,x					; put in VGA area
			lda	#$02							; enable 64 column text
			sta	SLOTENH,x					; set enhanced param
			ldd	#SCRBEG						; mode 64 screen beginning
			std	PageMod+1					; modify routine SetMode
			lda	#$a0							; value to have CSS0 in mode 64
			sta	CssMod+1						; modify routine SetMode
			lda	#$1d							; point to -3,x
			sta	SamMod+1						; modify routine SetMode
			rts									; return
; ===============================================================================================================
; send page to module CoCo-VGA
; AppluyMod	will ensure some parameters have the desired default values
; SetModT   will use the VGA data area as it has been filled
; ===============================================================================================================
ApplyMod										; Step 1 - fill VGA area to configure CoCoVGA
			ldx	#vgaRegs						; point to VGA area
			lda	SLOTEDT,x					; get edit param
			ora	#$ac							; enable enhanced modes, font
			sta	SLOTEDT,x					; update value
			lda	SLOTENH,x					; get enhanced modes param
			ora	#$02							; enable 64 column text
			sta	SLOTENH,x					; update value
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
												; Step 2 - Wait for VSYNC, which signals the start of the vertical blanking region.
SetModT	pshs	cc     						; save CC
			orcc	#INTDIS  					; mask interrupts
			ldu	#PIA0BCTL					; pointer for PIA0 B-side
			lda	,u	 							; $ff03 - get PIA config
			pshs	a      						; save PIA configuration 
			ora	#$04   						; ensure PIA 0B is NOT setting direction
			sta	,u								; $ff03 - update value
			anda	#$fd   						; vsync flag - trigger on falling edge
			sta	,u								; $ff03 - update value
			ora	#$01   						; enable vsync IRQ (although interrupt itself will be ignored via mask)
			sta	,u								; $ff03 - update value
			lda	-1,u  						; $ff02 - clear any pending VSYNC
L01		lda	,u		  						; $ff03 - wait for flag to indicate...
			bpl	L01     						; ...falling edge of FS (Field Sync)
			lda	-1,u  						; $ff02 - clear VSYNC interrupt flag
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 												; Step 3 - During VSYNC, point SAM to 512 byte page set up in step 1 (via SAM page select registers $FFC6-$FFD3)
 			ldd	#vgaRegs						; point to VGA data area beginning
 			bsr	SetSAM						; set SAM to access this area
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 												; Step 4 - Also during VSYNC, write 6847 VDG combination lock via PIA1B ($FF22) bits 7:3.
			ldy	#PIA1BDAT					; pointer for PIA1 B-side
			lda	,y  							; $ff22 - get current PIA value
			anda	#%00000111					; mask off bits to change
			ora	#%10010000					; $90 - set combo lock 1
			sta	,y  							; $ff22 - write to PIA
			anda	#%00000111					; mask off bits to change
			ora	#%01001000					; $48 - set combo lock 2
			sta	,y  							; $ff22 - write to PIA
			anda	#%00000111					; mask off bits to change
			ora	#%10100000					; $a0 - set combo lock 3
			sta	,y  							; $ff22 - write to PIA
			anda	#%00000111					; mask off bits to change
			ora	#%11111000 					; $f8 - set combo lock 4
			sta	,y	  							; $ff22 - write to PIA
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 												; Step 5 - Still during VSYNC, configure VDG and SAM back to mode 0 
												; In this case, the desired CoCoVGA register page to program is 0
			lda	,y	  							; $ff22 - get current PIA value
			anda	#%00000111					; mask off bits to change
			ora	#%00000000					; select CoCoVGA register page 0
			sta	,y	  							; $ff22 - write to PIA
			sta	-6,x  						; $ffc0 - clear SAM_V0	0
			sta	-4,x  						; $ffc2 - clear SAM_V1	0
			sta	-2,x  						; $ffc4 - clear SAM_V2	0	-> 000
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 												; Step 6 -  Wait for next VSYNC while SAM and VDG stream in the entire page of register values 
 												; to CoCoVGA and CoCoVGA displays the previous frame of video
L02		lda	,u								; $ff03 - wait for flag to indicate...
			bpl	L02     						; ...falling edge of FS (Field Sync)
			lda	-1,u  						; $ff02 - clear VSYNC interrupt flag
			puls	a      						; from stack... 
			sta	,u	 							; $ff03 - ...restore original PIA configuration
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 												; Step 7 - Point SAM page select to video page you want to display
PageMod	ldd	#SCRBEG						; point to text screen beginning (selfmodified)
 			bsr	SetSAM						; set SAM to access this area
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 												; Step 8 - Program SAM and VDG to the appropriate video mode. 
 												; For 32x16 text and graphics, GM is 0 and A/G is 0.
			lda	,y		  						; $ff22 - get current PIA value
			anda	#$0f  						; mask off bits to change
CssMod	ora	#%10100000					; ready for CSS0 (selfmodified)
			tst	curCcs						; is curent palette 0?
			beq	PutCss						; yes, skip next two
			ora	#%00001000					; set bit3 to ensure color palete 1
PutCss	sta	,y		  						; $ff22 - write to PIA
			sta	-6,x  						; $ffc0 - clear SAM_V0
SamMod	sta	-3,x  						; $ffc3 - set SAM_V1 (selfmodified)
			sta	-2,x  						; $ffc4 - clear SAM_V2	-> 010
			puls	cc,pc    					; restore ability to see interrupts and return
; ---------------------------------------------------------------------------------------------------------------
; set SAM memory address properly. regD must contain ADDRESS
; ---------------------------------------------------------------------------------------------------------------
SetSAM	ldx	#SAMADDRS					; $ffc6 - pointer for SAM Display Offset
			asra									; use high byte divided by two = regD/512
SamF0		bita	#%00000001					; is bit 0 set?
			bne	SetF0							; yes, setF0
			stb	,x		  						; $c6 - clear 	SAM_F0
			bra	SamF1							; skip next
SetF0		stb	1,x	  						; $c7 - set 	SAM_F0
SamF1		bita	#%00000010					; is bit 1 set?
			bne	SetF1							; yes, setF1
			stb	2,x	  						; $c8 - clear	SAM_F1
			bra	SamF2							; skip next
SetF1		stb	3,x	  						; $c9 - set 	SAM_F1
SamF2		bita	#%00000100					; is bit 2 set?
			bne	SetF2							; yes, setF2
			stb	4,x	  						; $ca - clear 	SAM_F2
			bra	SamF3							; skip next
SetF2		stb	5,x	  						; $cb - set 	SAM_F2
SamF3		bita	#%00001000					; is bit 3 set?
			bne	SetF3							; yes, setF3
			stb	6,x	  						; $cc - clear 	SAM_F3
			bra	SamF4							; skip next
SetF3		stb	7,x	  						; $cd - set 	SAM_F3
SamF4		bita	#%00010000					; is bit 4 set?
			bne	SetF4							; yes, setF4
			stb	8,x	  						; $ce - clear 	SAM_F4
			bra	SamF5							; skip next
SetF4		stb	9,x	  						; $cf - set 	SAM_F4
SamF5		bita	#%00100000					; is bit 5 set?
			bne	SetF5							; yes, setF5
			stb	10,x  						; $d0 - clear 	SAM_F5
			bra	SamF6							; skip next
SetF5		stb	11,x  						; $d1 - set 	SAM_F5
SamF6		bita	#%01000000					; is bit 6 set?
			bne	SetF6							; yes, setF6
			stb	12,x  						; $d2 - clear 	SAM_F6
			rts									; return
SetF6		stb	13,x  						; $d3 - set 	SAM_F6
			rts									; return
; ===============================================================================================================
; offsets for individual slots in VGA area - indexed by item on main menu screen
; ---------------------------------------------------------------------------------------------------------------
vgaOff	fcb	32								; VGA area offset for Black
			fcb	34,36,38,40					; VGA area offset for Green,Yellow,Blue,Red
			fcb	42,44,46,48					; VGA area offset for Buff,Cyan,Magenta,Orange
			fcb	132							; VGA area offset for Border
			fcb	50,52							; VGA area offset for darkGreen,darkOrange
			fcb	128,130,134					; VGA area offset for textForeground,background,scanline
; ---------------------------------------------------------------------------------------------------------------
; offsets for individual slots to their title on menu screen
; ---------------------------------------------------------------------------------------------------------------
elemOff	fdb	  	  64+2, 		 64+15, 		 64+28, 		 64+41, 		 64+54	; first row
			fdb	 640+64+2,  640+64+15,  640+64+28,  640+64+41,  640+64+54	; second row
			fdb	1280+64+2, 1280+64+15, 1280+64+28, 1280+64+41, 1280+64+54	; 3rd row
; ---------------------------------------------------------------------------------------------------------------
;					 ....+....1....+....2....+....3....+....4....+....5....+....6....
menuMain	fcb	/  Quit      Edit      Dir       Load      Save      Reset    /,0
;menuEdt	fcb	/  Out     Enable    Disable     Up-Down color    /,124,/ /,126,/ level /,0
menuEdt	fcb	/  Out    Enable   Disable  CURSOR UP-DWN color   /,124,/ /,126,/ level /,0
menuQuit fcb	/  Back         Continue                CHANGES/,96,/NOT/,96,/SAVED   /,0
descReq	fcc	/ENTER DESCRIPTION (MAX 24 CHAR):"/
descArea fcc	/                    "/,0;	
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
cpyScanL	fcb	$00							; copy of scanline bit (must be 0 or 4)
curCcs	fcb	$00							; CCS currently being used
datChg	fcb	$00							; flag for data has changed
datRGB	fdb	$0000							; 2 bytes read from VGA area
edtColN	fcb	$00							; component colour being edited (1-2-3 = RGB)
elemen	fcb	$00							; colour element 
maxChar	fcb	$00							; max number of chars to be read from keyboard
numChar	fcb	$00							; filename char counter
rgbPtr	fdb	$0000							; pointer to RGB data fields
spcAllw	fcb	$00							; space allowed from Keyboard
titlePtr	fdb	$0000							; pointer to title 1st char
; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; longest command will be: SAVE"FILENAME.PAL",4864,4896,0
; chars needed					     ....+....1....+....2....+ -> 25+zero ending = 26
	IF COCO
dosCmd	fcb	0,0,0,0,0,/"/									; command and leading quotes
dosParms	rzb	26													; area for command parameters
PARMLEN	equ	loadFil-dosParms
loadFil	fcc	/LOADM/											; load text string
saveFil	fcc	/SAVEM/											; save text string
dirTxt	fcn	/DIR /											; command DIR
	ELSE
dosCmd	fcb	0,0,0,0,/"/										; command and leading quotes
dosParms	rzb	26													; area for command parameters
PARMLEN	equ	loadFil-dosParms
loadFil	fcc	/LOAD/											; load text string
saveFil	fcc	/SAVE/											; save text string
dirTxt	fcn	/DIR/												; command DIR
	ENDIF
saveMem	fcn	/,4864,4922,0/									; save addresses: $1300, $133A
textN		fcn	/ENTER FILENAME: "/							; message to ask for filename
doneW		fcn	/OPERATION DONE. PRESS KEY/				; ok message
; ---------------------------------------------------------------------------------------------------------------
	IF COCO
mainMenu	includebin	"NEW6459C.ROM"		; default main menu in 64 column mode
	ELSE
mainMenu	includebin	"NEW6459D.ROM"		; default main menu in 64 column mode
	ENDIF
; ---------------------------------------------------------------------------------------------------------------
												; this part ensures Drivewire compatibility
	IF COCO
		IF ((*+10)%256 > 0)					; if not multiple of 256
				rzb	 256-((*+10)%256)		; fill to make it DW4 compatible
		ENDIF										; end
	ELSE
		IF ((*+9)%256 > 0)					; if not multiple of 256
				rzb	 256-((*+9)%256)		; fill to make it DW4 compatible
		ENDIF										; end
	ENDIF
; ------------------------------------------------------------------------------------------
PgmEnd	equ	*
